<script setup>
import { ref, onMounted } from "vue";
import { useConnectionStore } from "@/stores/Connection";

const connectionStore = useConnectionStore();

const isChecked = ref(localStorage.getItem("theme") === "dark");

const changeTheme = (value) => {
  const prefersDark = value;
  document.documentElement.setAttribute(
    "data-bs-theme",
    prefersDark ? "dark" : "light",
  );
  isChecked.value = prefersDark;
  localStorage.setItem("theme", prefersDark ? "dark" : "light");
};
onMounted(() => {
  changeTheme(isChecked.value);
});
</script>

<template>
  <div class="position-relative">
    <div class="position-absolute z-3 w-100">
      <div class="d-flex align-middle justify-content-between">
        <div class="d-flex">
          <div class="me-1">Connection:</div>
          <div v-if="connectionStore.isConnected">
            <div class="text-success">
              <i class="bi bi-check-circle-fill"></i>
            </div>
          </div>
          <div v-else-if="connectionStore.connecting">
            <div
              class="spinner-border text-warning spinner-border-sm"
              role="status"
            >
              <span class="visually-hidden">Connecting...</span>
            </div>
          </div>
          <div v-else>
            <div class="text-danger">
              <i class="bi bi-exclamation-circle-fill"></i>
            </div>
          </div>
        </div>
        <div>
          <button
            v-if="isChecked"
            type="button"
            class="btn btn-light"
            @click="changeTheme(false)"
          >
            <i class="bi bi-sun-fill"></i>
          </button>
          <button
            v-else
            type="button"
            class="btn btn-dark"
            @click="changeTheme(true)"
          >
            <i class="bi bi-moon-fill"></i>
          </button>
        </div>
      </div>
    </div>
  </div>
</template>
